(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@s-libs/rxjs-core'), require('@angular/forms'), require('@s-libs/micro-dash')) :
    typeof define === 'function' && define.amd ? define('@s-libs/ng-core', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@s-libs/rxjs-core', '@angular/forms', '@s-libs/micro-dash'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['s-libs'] = global['s-libs'] || {}, global['s-libs']['ng-core'] = {}), global.ng.core, global.rxjs, global.rxjs.operators, global.rxjsCore, global.ng.forms, global.microDash));
}(this, (function (exports, core, rxjs, operators, rxjsCore, forms, microDash) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * Use as the superclass for anything managed by angular's dependency injection for care-free use of `subscribeTo()`. It simply calls `unsubscribe()` during `ngOnDestroy()`. If you override `ngOnDestroy()` in your subclass, be sure to invoke the super implementation.
     *
     * ```ts
     * @Injectable()
     * // or @Component() (also consider DirectiveSuperclass)
     * // or @Directive() (also consider DirectiveSuperclass)
     * // or @Pipe()
     * class MyThing extends InjectableSuperclass {
     *   constructor(somethingObservable: Observable) {
     *     super();
     *     this.subscribeTo(somethingObservable);
     *   }
     *
     *   ngOnDestroy() {
     *     // if you override ngOnDestroy, be sure to call this too
     *     super.ngOnDestroy();
     *   }
     * }
     * ```
     */
    var InjectableSuperclass = /** @class */ (function (_super) {
        __extends(InjectableSuperclass, _super);
        function InjectableSuperclass() {
            var _this = _super.call(this) || this;
            _this.destructionSubject = new rxjs.Subject();
            _this.destruction$ = _this.destructionSubject.asObservable();
            return _this;
        }
        InjectableSuperclass.prototype.ngOnDestroy = function () {
            this.unsubscribe();
            this.destructionSubject.next();
            this.destructionSubject.complete();
        };
        return InjectableSuperclass;
    }(rxjsCore.SubscriptionManager));

    /**
     * Extend this when creating a directive (including a component, which is a kind of directive) to gain access to the helpers demonstrated below. **Warning:** You _must_ include a constructor in your subclass.
     *
     * ```ts
     * @Component({
     *   selector: "s-color-text",
     *   template: `
     *     <span [style.background]="color">{{ color }}</span>
     *   `,
     *   // note that `bindToInstance()` works even with OnPush change detection
     *   changeDetection: ChangeDetectionStrategy.OnPush,
     * })
     *  class ColorTextComponent extends DirectiveSuperclass {
     *   @Input() prefix?: string;
     *   @Input() prefix2?: string;
     *   color!: string;
     *
     *   // Even if you don't need extra arguments injector, you must still include a constructor. It is required for angular to provide `Injector`.
     *   constructor(
     *     @Inject("color$") color$: Observable<string>,
     *     injector: Injector,
     *   ) {
     *     super(injector);
     *
     *     // combine everything to calculate `color` and keep it up to date
     *     this.bindToInstance(
     *       "color",
     *       combineLatest(
     *         this.getInput$("prefix"),
     *         this.getInput$("prefix2"),
     *         color$,
     *       ).pipe(map((parts) => parts.filter((p) => p).join(""))),
     *     );
     *   }
     * }
     * ```
     */
    var DirectiveSuperclass = /** @class */ (function (_super) {
        __extends(DirectiveSuperclass, _super);
        function DirectiveSuperclass(injector) {
            var _this = _super.call(this) || this;
            /**
             *  Emits the set of `@Input()` property names that change during each call to `ngOnChanges()`.
             */
            _this.inputChanges$ = new rxjs.Subject();
            _this.changeDetectorRef = injector.get(core.ChangeDetectorRef);
            return _this;
        }
        DirectiveSuperclass.prototype.ngOnChanges = function (changes) {
            this.inputChanges$.next(new Set(Object.getOwnPropertyNames(changes)));
        };
        /**
         * @return an observable of the values for one of this directive's `@Input()` properties
         */
        DirectiveSuperclass.prototype.getInput$ = function (key) {
            var _this = this;
            return this.inputChanges$.pipe(operators.filter(function (keys) { return keys.has(key); }), operators.startWith(undefined), operators.map(function () { return _this[key]; }));
        };
        /**
         * Binds an observable to one of this directive's instance variables. When the observable emits the instance variable will be updated, and change detection will be triggered to propagate any changes. Use this an an alternative to repeating `| async` multiple times in your template.
         */
        DirectiveSuperclass.prototype.bindToInstance = function (key, value$) {
            var _this = this;
            this.subscribeTo(value$, function (value) {
                _this[key] = value;
                _this.changeDetectorRef.markForCheck();
            });
        };
        return DirectiveSuperclass;
    }(InjectableSuperclass));

    /**
     * Use in the `providers` of a component that implements `ControlValueAccessor` to reduce some boilerplate.
     *
     * ```ts
     * @Component({ providers: [provideValueAccessor(MyFormControl)] }
     * class MyFormControl extends BaseFormControl {
     *   // ...
     * }
     * ```
     */
    function provideValueAccessor(type) {
        return {
            provide: forms.NG_VALUE_ACCESSOR,
            useExisting: type,
            multi: true,
        };
    }
    /**
     * Extend this when creating a form control to reduce some boilerplate. **Warning:** You _must_ include a constructor in your subclass.
     *
     * This example allows 2-way binding to a number via `[(ngModel)]`, `[formControl]`, or any other technique that leverages the `ControlValueAccessor` interface.
     * ```ts
     * @Component({
     *   template: `
     *     <button (click)="increment()" [disabled]="isDisabled">{{ counter }}</button>
     *   `,
     *   providers: [provideValueAccessor(CounterComponent)],
     * })
     * class CounterComponent extends FormControlSuperclass<number> {
     *   counter = 0;
     *
     *   // This looks unnecessary, but is required for Angular to provide `Injector`
     *   constructor(injector: Injector) {
     *     super(injector);
     *   }
     *
     *   handleIncomingValue(value: number) {
     *     this.counter = value;
     *   }
     *
     *   increment() {
     *     this.emitOutgoingValue(++this.counter);
     *     this.onTouched();
     *   }
     * }
     * ```
     */
    var FormControlSuperclass = /** @class */ (function (_super) {
        __extends(FormControlSuperclass, _super);
        function FormControlSuperclass() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            /** Call this to emit a new value when it changes. */
            _this.emitOutgoingValue = microDash.noop;
            /** Call this to "commit" a change, traditionally done e.g. on blur. */
            _this.onTouched = microDash.noop;
            /** You can bind to this in your template as needed. */
            _this.isDisabled = false;
            return _this;
        }
        /** Called as angular propagates value changes to this `ControlValueAccessor`. You normally do not need to use it. */
        FormControlSuperclass.prototype.writeValue = function (value) {
            this.handleIncomingValue(value);
            this.changeDetectorRef.markForCheck();
        };
        /** Called as angular sets up the binding to this `ControlValueAccessor`. You normally do not need to use it. */
        FormControlSuperclass.prototype.registerOnChange = function (fn) {
            this.emitOutgoingValue = fn;
        };
        /** Called as angular sets up the binding to this `ControlValueAccessor`. You normally do not need to use it. */
        FormControlSuperclass.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        /** Called as angular propagates disabled changes to this `ControlValueAccessor`. You normally do not need to use it. */
        FormControlSuperclass.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
            this.changeDetectorRef.markForCheck();
        };
        return FormControlSuperclass;
    }(DirectiveSuperclass));

    /**
     * Extend this when creating a form control that simply wraps an existing form control, to reduce a lot of boilerplate. **Warning:** You _must_ include a constructor in your subclass.
     *
     * Example when you don't need to modify the wrapped control's value:
     * ```ts
     * @Component({
     *   template: `<input [formControl]="formControl">`,
     *   providers: [provideValueAccessor(StringComponent)],
     * })
     * class StringComponent extends WrappedFormControlSuperclass<string> {
     *   // This looks unnecessary, but is required for Angular to provide `Injector`
     *   constructor(injector: Injector) {
     *     super(injector);
     *   }
     * }
     * ```
     *
     * Example when you need to modify the wrapped control's value:
     * ```ts
     * @Component({
     *   template: `<input type="datetime-local" [formControl]="formControl">`,
     *   providers: [provideValueAccessor(DateComponent)],
     * })
     * class DateComponent extends WrappedFormControlSuperclass<Date, string> {
     *   // This looks unnecessary, but is required for Angular to provide `Injector`
     *   constructor(injector: Injector) {
     *     super(injector);
     *   }
     *
     *   protected innerToOuter(value: string): Date {
     *     return new Date(value + "Z");
     *   }
     *
     *   protected outerToInner(value: Date): string {
     *     if (value === null) {
     *       return ""; // happens during initialization
     *     }
     *     return value.toISOString().substr(0, 16);
     *   }
     * }
     * ```
     */
    var WrappedFormControlSuperclass = /** @class */ (function (_super) {
        __extends(WrappedFormControlSuperclass, _super);
        function WrappedFormControlSuperclass(injector) {
            var _this = _super.call(this, injector) || this;
            /** Bind this to your inner form control to make all the magic happen. */
            _this.formControl = new forms.FormControl();
            _this.subscribeTo(_this.formControl.valueChanges, function (value) {
                _this.emitOutgoingValue(_this.innerToOuter(value));
            });
            _this.formControl.markAsTouched = function () {
                _this.onTouched();
            };
            return _this;
        }
        /** Called as angular propagates values changes to this `ControlValueAccessor`. You normally do not need to use it. */
        WrappedFormControlSuperclass.prototype.handleIncomingValue = function (value) {
            this.formControl.setValue(this.outerToInner(value), { emitEvent: false });
        };
        /** Called as angular propagates disabled changes to this `ControlValueAccessor`. You normally do not need to use it. */
        WrappedFormControlSuperclass.prototype.setDisabledState = function (isDisabled) {
            if (isDisabled) {
                this.formControl.disable({ emitEvent: false });
            }
            else {
                this.formControl.enable({ emitEvent: false });
            }
            _super.prototype.setDisabledState.call(this, this.isDisabled);
        };
        /** Override this to modify a value coming from the outside to the format needed within this component. */
        WrappedFormControlSuperclass.prototype.outerToInner = function (value) {
            return value;
        };
        /** Override this to modify a value coming from within this component to the format expected on the outside. */
        WrappedFormControlSuperclass.prototype.innerToOuter = function (value) {
            return value;
        };
        return WrappedFormControlSuperclass;
    }(FormControlSuperclass));

    /*
     * Public API Surface of ng-core
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DirectiveSuperclass = DirectiveSuperclass;
    exports.FormControlSuperclass = FormControlSuperclass;
    exports.InjectableSuperclass = InjectableSuperclass;
    exports.WrappedFormControlSuperclass = WrappedFormControlSuperclass;
    exports.provideValueAccessor = provideValueAccessor;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=s-libs-ng-core.umd.js.map
